import org.scalatest.flatspec.AnyFlatSpec
import org.wikimedia.mediawiki.event.enrichment.{
    Content,
    buildRevisionContentQueryUri
}

// scalastyle:off line.size.limit
class ContentSuite extends AnyFlatSpec {

    "Content" should "be extracted from a json payload" in {

        // generated by
        // curl "https://en.wikipedia.org/w/api.php?action=query&format=json&prop=revisions&revids=1088481788&formatversion=2&rvprop=content&rvslots=main"
        val jsonString =
            """
              |{
              |    "batchcomplete": true,
              |    "query": {
              |        "pages": [
              |            {
              |                "pageid": 70812160,
              |                "ns": 14,
              |                "title": "Category:Works and transport ministers of Namibia",
              |                "revisions": [
              |                    {
              |                        "slots": {
              |                            "main": {
              |                                "contentmodel": "wikitext",
              |                                "contentformat": "text/x-wiki",
              |                                "content": "[[Category:Transport ministers by country|Namibia]]\n[[Category:Government ministers of Namibia]]"
              |                            }
              |                        }
              |                    }
              |                ]
              |            }
              |        ]
              |    }
              |}""".stripMargin

        val expected = Content(
          title = "Category:Works and transport ministers of Namibia",
          article_id = 70812160,
          contentmodel = Option("wikitext"),
          contentformat = Option("text/x-wiki"),
          content = Option(
            "[[Category:Transport ministers by country|Namibia]]\n[[Category:Government ministers of Namibia]]"
          )
        )

        val content = Content.from(jsonString).get

        assert(expected === content)
    }

    "A json payload with no pages" should "result in a parsing error" in {
        val jsonString =
            """
              |{
              |    "batchcomplete": true,
              |    "query": {
              |        "pages": []
              |    }
              |}""".stripMargin

        val thrown = intercept[NoSuchElementException] {
            Content.from(jsonString).get
        }
        assert("Page data is missing from payload" === thrown.getMessage)
    }

    "A json payload with no revisions" should "result in a parsing error" in {
        val jsonString =
            """
              |{
              |    "batchcomplete": true,
              |    "query": {
              |        "pages": [
              |            {
              |                "pageid": 70812160,
              |                "ns": 14,
              |                "title": "Category:Works and transport ministers of Namibia",
              |                "revisions": []
              |            }
              |        ]
              |    }
              |}""".stripMargin

        val thrown = intercept[NoSuchElementException] {
            Content.from(jsonString).get
        }
        assert("Revision data is missing from payload" === thrown.getMessage)
    }

    "A valid query returning a missing revision id payload " should "trigger an execption in the content  parser" in {
        val missingRevId = Int.MaxValue

        // FIXME(gmodena, 2022-06-07) duplicates a fixture in EnrichmentIntegrationTest
        val missingRevIdResponse =
            s"""
               |{
               |    "batchcomplete": true,
               |    "query": {
               |        "badrevids": {
               |            "$missingRevId": {
               |                "revid": $missingRevId,
               |                "missing": true
               |            }
               |        }
               |    }
               |}
               |""".stripMargin

        assert(Content.from(missingRevIdResponse).isFailure)
    }
    "A query string" should "be generated for a page and revision id" in {
        // By default we query api-ro.discovery.
        val url = "api-ro.discovery.wmnet/w/api.php"
        val revisionId = 1088481788L
        val formatVersion = 2
        // Query params used to generated the Content test case.
        val params =
            s"""action=query&format=json&formatversion=${formatVersion}&prop=revisions&revids=${revisionId}&rvprop=content&rvslots=main"""
        val expectedUri = s"https://$url?$params"

        val actionQueryUri = buildRevisionContentQueryUri(revisionId)
        assert(expectedUri === actionQueryUri)
    }
}
